package cp.gui;

import cp.RoundDate;
import cp.Tournament;
import cp.db.Settings;
import java.awt.*;
import java.awt.Dimension;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.sql.SQLException;
import java.text.*;
import java.util.Date;
import java.util.Vector;
import javax.swing.*;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.border.EtchedBorder;
import javax.swing.text.*;

public class TournamentDialog extends JDialog {
  private JLabel jLabel1 = new JLabel();
  private JTextField jTextFieldName = new JTextField();
  private JLabel jLabel2 = new JLabel();
  private JTextField jTextFieldGroup = new JTextField();
  private JLabel jLabel3 = new JLabel();
  private JComboBox jComboBoxPairingSystem = new JComboBox();
  private JComboBox jComboBoxInitialPairing = new JComboBox();
  private JSpinner jSpinnerRounds = new JSpinner();
  private JCheckBox jCheckBoxBarred = new JCheckBox();
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private GridBagLayout gridBagLayout2 = new GridBagLayout();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton jButtonOK = new JButton();
  private JButton jButtonCancel = new JButton();
  private JLabel jLabel4 = new JLabel();
  private JLabel jLabel5 = new JLabel();
  private JLabel jLabel6 = new JLabel();
  private JLabel jLabel7 = new JLabel();
  private Tournament tournament;
  private JTextField jTextFieldResults = new JTextField();
  private JLabel jLabel8 = new JLabel();
  private JTextField jTextFieldStandings = new JTextField();
  private JLabel jLabel9 = new JLabel();
  private Settings settings;
  private JLabel jLabel10 = new JLabel();
  private JTextField jTextFieldPlayerList = new JTextField();
  private JLabel jLabel12 = new JLabel();
  private JTextField jTextFieldRoundForRound = new JTextField();
  private JLabel jLabel13 = new JLabel();
  private JSpinner jSpinnerPoints = new JSpinner();
  private TournamentDialogTiebreak jPanelTiebreak = new TournamentDialogTiebreak();
  private JCheckBox jCheckBoxCompensateWeakPlayerPP = new JCheckBox();
  private JLabel jLabel15 = new JLabel();
  private JLabel jLabel16 = new JLabel();
  private JCheckBox jCheckBoxChess4 = new JCheckBox();
  private JLabel jLabel17 = new JLabel();
  private JLabel jLabel18 = new JLabel();
  private JTextField jTextFieldClubStandings = new JTextField();
  private JLabel jLabel19 = new JLabel();
  private JLabel jLabel20 = new JLabel();
  private JTabbedPane jTabbedPane1 = new JTabbedPane();
  private JPanel jPanelSettings = new JPanel();
  private JPanel jPanelWeb = new JPanel();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private GridBagLayout gridBagLayout3 = new GridBagLayout();
  private JLabel jLabelExpander2 = new JLabel();
  private JLabel jLabelExpander = new JLabel();
  private JLabel jLabel11 = new JLabel();
  private JComboBox jComboBoxRatingChoice = new JComboBox();
  private JLabel jLabel14 = new JLabel();
  private JPanel jPanelFIDE = new JPanel();
  private GridBagLayout gridBagLayout4 = new GridBagLayout();
  private JLabel jLabel21 = new JLabel();
  private JTextField jTextFieldCity = new JTextField();
  private JTextField jTextFieldFed = new JTextField();
  private JLabel jLabel22 = new JLabel();
  private JLabel jLabel23 = new JLabel();
  private JLabel jLabel24 = new JLabel();
  private JFormattedTextField jFormattedTextFieldStart = new JFormattedTextField();
  private JFormattedTextField jFormattedTextFieldEnd = new JFormattedTextField();
  private JLabel jLabel25 = new JLabel();
  private JLabel jLabel26 = new JLabel();
  private JLabel jLabel27 = new JLabel();
  private JTextField jTextFieldArbiter = new JTextField();
  private JTextField jTextFieldDeputyArbiter = new JTextField();
  private JTextField jTextFieldTimeControl = new JTextField();
  private JLabel jLabelExpander3 = new JLabel();
  private JLabel jLabel29 = new JLabel();
  private JLabel jLabel30 = new JLabel();
  private DefaultListModel roundDatesModel = new DefaultListModel();
  private JCheckBox jCheckBoxELO = new JCheckBox();
  private JCheckBox jCheckBoxLASK = new JCheckBox();
  private JCheckBox jCheckBoxGroup = new JCheckBox();
  private JPanel jPanelRoundList = new JPanel();
  private GridBagLayout gridBagLayout5 = new GridBagLayout();
  private JList jListRoundDates = new JList(roundDatesModel);
  private JPanel jPanelRounds = new JPanel();
  private JButton jButtonAddRoundDate = new JButton();
  private JButton jButtonRemoveRoundDate = new JButton();
  private GridBagLayout gridBagLayout6 = new GridBagLayout();
  private JLabel jLabel28 = new JLabel();
  private JFormattedTextField jFormattedTextFieldRound = new JFormattedTextField();
  private JLabel jLabel31 = new JLabel();
  private JSpinner jSpinnerRound = new JSpinner();
  private JLabel jLabel32 = new JLabel();
  private DateFormatter dateFormatter;
  private JLabel jLabel33 = new JLabel();

  public TournamentDialog(Settings settings, Image icon) {
    super();
    this.settings = settings;
    this.setIconImage(icon);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jPanelFIDE.setLayout(gridBagLayout4);
    jPanelRoundList.setLayout(gridBagLayout5);
    jPanel1.setLayout(gridBagLayout2);
    jPanelSettings.setLayout(gridBagLayout1);
    jPanelWeb.setLayout(gridBagLayout3);
    jPanelRounds.setLayout(gridBagLayout6);
    this.setModal(true);
    this.setTitle("Turneringsinstllningar");
    jLabel1.setText("Turnering");
    jLabel2.setText("Grupp");
    jLabel3.setText("Lottningssystem");
    jSpinnerRounds.setPreferredSize(new Dimension(40, 20));
    jSpinnerPoints.setPreferredSize(new Dimension(40, 20));
    jCheckBoxBarred.setToolTipText("Om denna r vald kommer medlemmar i samma klubb inte att mtas");
    jButtonOK.setText("Spara");
    jButtonOK.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonOK_actionPerformed();
        }
      });
    jButtonCancel.setText("Avbryt");
    jButtonCancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonCancel_actionPerformed();
        }
      });
    jLabel4.setText("Srskiljning");
    jLabel5.setText("Initial spelarordning");
    jLabel6.setText("Antal ronder");
    jLabel7.setText("Lt ej spelare frn");
    jTextFieldResults.setText("lottning.htm");
    jLabel20.setText("samma klubb mtas");
    jLabel11.setText("Vid schweizerlottning:");
    jLabel8.setText("Lottning html-fil");
    jTextFieldStandings.setText("stallning.htm");
    jLabel9.setText("Stllning html-fil");
    jLabel10.setText("Spelarlista html-fil");
    jTextFieldPlayerList.setText("spelare.htm");
    jLabel12.setText("Korstabell html-fil");
    jTextFieldRoundForRound.setText("korstabell.htm");
    jLabel13.setText("Pong per match");
    jPanel1.add(jLabel1, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldName, new GridBagConstraints(4, 0, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldGroup, new GridBagConstraints(4, 1, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel2.add(jButtonOK, null);
    jPanel2.add(jButtonCancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jButtonCancel.setModel(new DefaultButtonModel());
    SpinnerModel modelRounds = new SpinnerNumberModel(9, 1, 1000, 1);
    SpinnerModel modelRoundDates = new SpinnerNumberModel(1, 1, 1000, 1);
    jSpinnerRounds.setModel(modelRounds);
    SpinnerModel modelPoints = new SpinnerNumberModel(1, 1, 100, 1);
    jSpinnerPoints.setModel(modelPoints);
    jCheckBoxCompensateWeakPlayerPP.setToolTipText("Nr ett parti r uppskjutet rknas resultatet som remi fr den svagare spelare om ratingskillnaden r > 200p. Annars rknas det som vinst fr bda.");
    jLabel15.setText("som remi fr den svagare");
    jLabel16.setText("Rkna uppskjutna partier");
    jCheckBoxChess4.addItemListener(new ItemListener() {
        public void itemStateChanged(ItemEvent e) {
          jCheckBoxChess4_itemStateChanged(e);
        }
      });
    jLabel17.setText("Detta r en schack4an-tvling");
    jLabel18.setText("Klubbstllning html-fil");
    jTextFieldClubStandings.setText("klubbstallning.htm");
    jLabel19.setText("(Schack4an stllning)");
    jPanelSettings.add(jLabel4, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanelSettings.add(jLabel3, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jComboBoxPairingSystem, new GridBagConstraints(2, 1, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 10, 0));
    jPanelSettings.add(jPanelTiebreak, new GridBagConstraints(2, 6, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(8, 0, 0, 8), 0, 0));
    jPanelSettings.add(jLabel5, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jComboBoxInitialPairing, new GridBagConstraints(2, 2, 1, 1, 2.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 10, 0));
    jPanelSettings.add(jLabel6, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jSpinnerRounds, new GridBagConstraints(2, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanelSettings.add(jLabel7, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jLabel20, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanelSettings.add(jCheckBoxBarred, new GridBagConstraints(2, 7, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanelSettings.add(jLabel16, new GridBagConstraints(0, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jLabel15, new GridBagConstraints(0, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanelSettings.add(jCheckBoxCompensateWeakPlayerPP, new GridBagConstraints(2, 9, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanelSettings.add(jLabel13, new GridBagConstraints(0, 11, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelSettings.add(jSpinnerPoints, new GridBagConstraints(2, 11, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanelSettings.add(jLabel17, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelSettings.add(jCheckBoxChess4, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 3, 0, 0), 0, 0));
    jPanelSettings.add(jLabelExpander, new GridBagConstraints(0, 12, 3, 1, 0.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelSettings.add(jLabel11, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelSettings.add(jComboBoxRatingChoice, new GridBagConstraints(2, 3, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 10, 0));
    jPanelSettings.add(jLabel14, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanelSettings.add(jCheckBoxELO, new GridBagConstraints(3, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelSettings.add(jCheckBoxLASK, new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelSettings.add(jCheckBoxGroup, new GridBagConstraints(3, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelWeb.add(jLabel8, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelWeb.add(jTextFieldResults, new GridBagConstraints(1, 1, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanelWeb.add(jLabel9, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelWeb.add(jLabel10, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelWeb.add(jLabel12, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 5), 0, 0));
    jPanelWeb.add(jLabel18, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanelWeb.add(jLabel19, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    jPanelWeb.add(jTextFieldStandings, new GridBagConstraints(1, 2, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanelWeb.add(jTextFieldPlayerList, new GridBagConstraints(1, 3, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanelWeb.add(jTextFieldRoundForRound, new GridBagConstraints(1, 4, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanelWeb.add(jTextFieldClubStandings, new GridBagConstraints(1, 5, 3, 2, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanelWeb.add(jLabelExpander2, new GridBagConstraints(0, 7, 4, 1, 0.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelWeb.add(jLabel33, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 10, 10, 10), 0, 0));
    jTabbedPane1.addTab("Lottningsinstllningar", jPanelSettings);
    jTabbedPane1.addTab("Webbpublicering", jPanelWeb);
    jPanelFIDE.addComponentListener(new ComponentAdapter() {
        public void componentShown(ComponentEvent e) {
          jPanelFIDE_componentShown();
        }
      });
    jPanelFIDE.add(jLabel21, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jTextFieldCity, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 10, 0, 20), 0, 0));
    jPanelFIDE.add(jTextFieldFed, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel22, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel23, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel24, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jFormattedTextFieldStart, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jFormattedTextFieldEnd, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel25, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel26, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel27, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jTextFieldArbiter, new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 10, 0, 20), 0, 0));
    jPanelFIDE.add(jTextFieldDeputyArbiter, new GridBagConstraints(1, 6, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 10, 0, 20), 0, 0));
    jPanelFIDE.add(jTextFieldTimeControl, new GridBagConstraints(1, 7, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 10, 0, 20), 0, 0));
    jPanelFIDE.add(jLabelExpander3, new GridBagConstraints(0, 9, 1, 1, 0.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelFIDE.add(jLabel29, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(8, 0, 10, 0), 0, 0));
    jPanelFIDE.add(jLabel30, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanelFIDE.add(jPanelRoundList, new GridBagConstraints(1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jTabbedPane1.addTab("FIDE-uppgifter", jPanelFIDE);
    jPanelRoundList.add(jPanelRounds, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 8), 0, 0));
    jPanelRounds.add(jButtonAddRoundDate, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 8, 0, 0), 0, 0));
    jPanelRounds.add(jButtonRemoveRoundDate, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 8, 0, 0), 0, 0));
    jPanelRounds.add(jLabel28, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelRounds.add(jFormattedTextFieldRound, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanelRounds.add(jSpinnerRound, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 8), 0, 0));
    jPanelRounds.add(jLabel32, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 8), 0, 0));
    jPanelRoundList.add(jLabel31, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 20), 0, 0));
    jPanelRoundList.add(jListRoundDates, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jTabbedPane1, new GridBagConstraints(1, 2, 5, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(8, 10, 0, 0), 0, 0));
    // Insert values in comboboxes.
    jComboBoxPairingSystem.addItem("Berger");
    jComboBoxPairingSystem.addItem("Monrad");
    jComboBoxPairingSystem.addItem("Nordisk Schweizer");
    jComboBoxPairingSystem.setSelectedIndex(2);
    jComboBoxInitialPairing.addItem("Slumpad");
    jComboBoxInitialPairing.addItem("Rating");
    jComboBoxInitialPairing.setSelectedIndex(1);
    jComboBoxRatingChoice.addItem("LASK");
    jComboBoxRatingChoice.addItem("ELO");
    jComboBoxRatingChoice.addItem("Hgsta av LASK & ELO");
    jComboBoxRatingChoice.addItem("Frst ELO, sen LASK");
    jComboBoxRatingChoice.setSelectedIndex(0);
    jLabel14.setText("Lotta med avseende p");
    jLabel21.setText("Stad");
    jTextFieldFed.setText("SWE");
    jTextFieldFed.setPreferredSize(new Dimension(40, 19));
    jTextFieldFed.setColumns(3);
    jLabel22.setText("Federation");
    jLabel23.setText("Startdatum");
    jLabel24.setText("Slutdatum");
    
    DefaultFormatterFactory factory = new DefaultFormatterFactory();
    dateFormatter = new DateFormatter(new SimpleDateFormat("yyyy-MM-dd"));
    factory.setDefaultFormatter(dateFormatter);
    jLabel33.setText("Dessa uppgifter behvs endast om man vill publicera sidor p internet.");
    jLabel33.setFont(new Font("Tahoma", 1, 11));
    jLabel32.setText("Rond");
    jLabel31.setText("Rondlista");
    jSpinnerRound.setSize(new Dimension(40, 20));
    jSpinnerRound.setMinimumSize(new Dimension(57, 19));
    jSpinnerRound.setPreferredSize(new Dimension(40, 20));
    jFormattedTextFieldRound.setFormatterFactory(factory);
    jFormattedTextFieldRound.setValue(new Date());
    jFormattedTextFieldRound.setToolTipText("Datum ska vara i formatet -MM-DD");
    jFormattedTextFieldRound.setPreferredSize(new Dimension(70, 19));
    jLabel28.setText("Datum");
    jButtonAddRoundDate.setText(">>");
    jButtonAddRoundDate.setMargin(new Insets(1, 1, 1, 1));
    jButtonAddRoundDate.setToolTipText("Lgg till ronddatum");
    jButtonAddRoundDate.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonAddRoundDate_actionPerformed();
        }
      });
    jButtonRemoveRoundDate.setText("<<");
    jButtonRemoveRoundDate.setMargin(new Insets(1, 1, 1, 1));
    jButtonRemoveRoundDate.setToolTipText("Ta bort ronddatum");
    jButtonRemoveRoundDate.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonRemoveRoundDate_actionPerformed();
        }
      });
    jListRoundDates.setPreferredSize(new Dimension(120, 150));
    jListRoundDates.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
    jCheckBoxGroup.setText("Visa Gruppkolumn");
		jCheckBoxGroup.setSelected(true);
		jCheckBoxELO.setText("Visa ELO-rating");
    jCheckBoxLASK.setText("Visa LASK-rating");
    jCheckBoxLASK.setSelected(true);
    jLabel30.setText("Speldatum fr ronder");
    jLabel29.setText("Uppgifter fr ELO-registrering till FIDE");
    jLabel29.setFont(new Font("Tahoma", 1, 11));
    jTextFieldTimeControl.setToolTipText("P engelska. Ex: 40/90min+30s/move, 30min+30s/move");
    jLabel25.setText("Huvuddomare");
    jLabel26.setText("Bitrdande domare");
    jLabel27.setText("Betnketid");
    jFormattedTextFieldEnd.setFormatterFactory(factory);
    jFormattedTextFieldEnd.setValue(new Date());
    jFormattedTextFieldStart.setFormatterFactory(factory);
    jFormattedTextFieldStart.setValue(new Date());
    jFormattedTextFieldStart.setToolTipText("Datum ska vara i formatet -MM-DD");
    jFormattedTextFieldStart.setPreferredSize(new Dimension(70, 19));
    jFormattedTextFieldEnd.setValue(new Date());


    jFormattedTextFieldEnd.setToolTipText("Datum ska vara i formatet -MM-DD");
    jFormattedTextFieldEnd.setPreferredSize(new Dimension(70, 19));
    jSpinnerRound.setModel(modelRoundDates);
    pack();
  }

  private void jButtonOK_actionPerformed() {
    if (!jTextFieldName.getText().isEmpty() && !jTextFieldGroup.getText().isEmpty()) {
      if (jButtonOK.getText().equals("Spara")) {
        tournament = new Tournament(settings);
        tournament.setName(jTextFieldName.getText());
        tournament.setGroup(jTextFieldGroup.getText());
      }
      // Pairing settings tab
      String pairingSystem = (String) jComboBoxPairingSystem.getSelectedItem();
      tournament.setPairingSystem(pairingSystem);
      tournament.setTiebreaks(jPanelTiebreak.getTiebreaks());
      tournament.setInitialPairing((String) jComboBoxInitialPairing.getSelectedItem());
      tournament.setRatingChoice(getRatingChoice((String) jComboBoxRatingChoice.getSelectedItem()));
      tournament.setShowLASK(jCheckBoxLASK.isSelected());
      tournament.setShowELO(jCheckBoxELO.isSelected());
			tournament.setShowGroup(jCheckBoxGroup.isSelected());
      tournament.setNrOfRounds((Integer) jSpinnerRounds.getValue());
      tournament.setBarredPairing(jCheckBoxBarred.isSelected());
      tournament.setCompensateWeakPlayerPP(jCheckBoxCompensateWeakPlayerPP.isSelected());
      tournament.setPointsPerGame((Integer) jSpinnerPoints.getValue());
      tournament.setIsChess4(jCheckBoxChess4.isSelected());
      // Web publishing tab
      if (!jTextFieldResults.getText().isEmpty()) {
        tournament.setResultsPage(jTextFieldResults.getText());
      }
      else {
        tournament.setResultsPage(null);
      }
      if (!jTextFieldStandings.getText().isEmpty()) {
        tournament.setStandingsPage(jTextFieldStandings.getText());
      }
      else {
        tournament.setStandingsPage(null);
      }
      if (!jTextFieldPlayerList.getText().isEmpty()) {
        tournament.setPlayerListPage(jTextFieldPlayerList.getText());
      }
      else {
        tournament.setPlayerListPage(null);
      }
      if (!jTextFieldRoundForRound.getText().isEmpty()) {
        tournament.setRoundForRoundPage(jTextFieldRoundForRound.getText());
      }
      else {
        tournament.setRoundForRoundPage(null);
      }
      if (!jTextFieldClubStandings.getText().isEmpty()) {
        tournament.setClubStandingsPage(jTextFieldClubStandings.getText());
      }
      else {
        tournament.setClubStandingsPage(null);
      }
      // FIDE tab
      tournament.setCity(jTextFieldCity.getText().trim());
      tournament.setFederation(jTextFieldFed.getText().toUpperCase().trim());
      tournament.setStartDate((Date)jFormattedTextFieldStart.getValue());
      tournament.setEndDate((Date)jFormattedTextFieldEnd.getValue());
      tournament.setChiefArbiter(jTextFieldArbiter.getText().trim());
      tournament.setDeputyArbiter(jTextFieldDeputyArbiter.getText().trim());
      tournament.setTimeControl(jTextFieldTimeControl.getText().trim());
      Vector<RoundDate> roundDates = new Vector<RoundDate>();
      for (int i=0; i<roundDatesModel.size(); i++) {
        roundDates.add((RoundDate)roundDatesModel.get(i));
      }
      tournament.setRoundDates(roundDates);
      try {
        if (jButtonOK.getText().equals("Uppdatera")) {
          tournament.update();
        }
        else {
          tournament.save();
        }
        this.setVisible(false);
      }
      catch (SQLException f) {
        if (f.getMessage().contains("duplicate key value")) {
          JOptionPane.showMessageDialog(this, "Turneringen finns redan.", "Information", JOptionPane.INFORMATION_MESSAGE);
        }
        else if (f.getMessage().contains("apostrof")) {
          JOptionPane.showMessageDialog(this, f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
        }
        else {
          JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
        }
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Vnligen ange turneringsnamn och grupp.", "Message", JOptionPane.INFORMATION_MESSAGE);
    }
  }

  public Tournament getTournament() {
    return tournament;
  }
  
  private void jButtonCancel_actionPerformed() {
    this.setVisible(false);
  }
  
  public void setTournament(Tournament tournament) {
    this.tournament = tournament;
    // Fill in fields and show update mode
    jTextFieldName.setText(tournament.getName());
    jTextFieldName.setEnabled(false);
    jTextFieldGroup.setText(tournament.getGroup());
    jTextFieldGroup.setEnabled(false);
    // Rating
    jComboBoxPairingSystem.setSelectedItem(tournament.getPairingSystem());
    jCheckBoxLASK.setSelected(tournament.getShowLASK());
    jCheckBoxELO.setSelected(tournament.getShowELO());
		jCheckBoxGroup.setSelected(tournament.getShowGroup());
    // Set up tiebreak
    jPanelTiebreak.setTiebreaks(tournament.getTiebreaks());
    
    jComboBoxInitialPairing.setSelectedItem(tournament.getInitialPairing());
    jSpinnerRounds.setValue(tournament.getNrOfRounds());
    jCheckBoxBarred.setSelected(tournament.isBarredPairing());
    jCheckBoxCompensateWeakPlayerPP.setSelected(tournament.isCompensateWeakPlayerPP());
    jCheckBoxChess4.setSelected(tournament.isChess4());
    jSpinnerPoints.setValue(tournament.getPointsPerGame());
    if (tournament.getResultsPage() != null) {
      jTextFieldResults.setText(tournament.getResultsPage());
    }
    else {
      jTextFieldResults.setText("");
    }
    if (tournament.getStandingsPage() != null) {
      jTextFieldStandings.setText(tournament.getStandingsPage());
    }
    else {
      jTextFieldStandings.setText("");
    }
    if (tournament.getPlayerListPage() != null) {
      jTextFieldPlayerList.setText(tournament.getPlayerListPage());
    }
    else {
      jTextFieldPlayerList.setText("");
    }
    if (tournament.getRoundForRoundPage() != null) {
      jTextFieldRoundForRound.setText(tournament.getRoundForRoundPage());
    }
    else {
      jTextFieldRoundForRound.setText("");
    }
    if (tournament.getClubStandingsPage() != null) {
      jTextFieldClubStandings.setText(tournament.getClubStandingsPage());
    }
    else {
      jTextFieldClubStandings.setText("");
    }
    // Rating
    jComboBoxRatingChoice.setSelectedItem(getText(tournament.getRatingChoice()));
    jCheckBoxLASK.setSelected(tournament.getShowLASK());
    jCheckBoxELO.setSelected(tournament.getShowELO());
    jCheckBoxGroup.setSelected(tournament.getShowGroup());
    jButtonOK.setText("Uppdatera");
    
    // FIDE panel
    jTextFieldCity.setText(tournament.getCity());
    jTextFieldFed.setText(tournament.getFederation());
    jFormattedTextFieldStart.setValue(tournament.getStartDate());
    jFormattedTextFieldEnd.setValue(tournament.getEndDate());
    jTextFieldArbiter.setText(tournament.getChiefArbiter());
    jTextFieldDeputyArbiter.setText(tournament.getDeputyArbiter());
    jTextFieldTimeControl.setText(tournament.getTimeControl());
    Vector<RoundDate> roundDates = tournament.getRoundDates();
    for (int i=0; i<roundDates.size(); i++) {
      roundDatesModel.addElement(roundDates.get(i));
    }
  }

  private Tournament.RatingChoice getRatingChoice(String value) {
    if (value.equalsIgnoreCase("LASK")) 
      return Tournament.RatingChoice.LASK;
    else if (value.equalsIgnoreCase("ELO")) 
      return Tournament.RatingChoice.ELO;
    else if (value.equalsIgnoreCase("Hgsta av LASK & ELO")) 
      return Tournament.RatingChoice.HIGHEST;
    else if (value.equalsIgnoreCase("Frst ELO, sen LASK")) 
      return Tournament.RatingChoice.ELO_THEN_LASK;
    return null;
  }
  
  private String getText(Tournament.RatingChoice value) {
    if (value == Tournament.RatingChoice.LASK) 
      return "LASK";
    else if (value == Tournament.RatingChoice.ELO) 
      return "ELO";
    else if (value == Tournament.RatingChoice.HIGHEST) 
      return "Hgsta av LASK & ELO";
    else if (value == Tournament.RatingChoice.ELO_THEN_LASK) 
      return "Frst ELO, sen LASK";
    return null;
  }

  private void jPanelFIDE_componentShown() {
    int rounds = (Integer)jSpinnerRounds.getValue();
    SpinnerModel model = new SpinnerNumberModel(1, 1, rounds, 1);
    jSpinnerRound.setModel(model);
  }

  private void jButtonAddRoundDate_actionPerformed() {
    try {
      Date date = (Date)dateFormatter.stringToValue(jFormattedTextFieldRound.getText());
      int round = (Integer)jSpinnerRound.getValue();
      RoundDate roundDate = new RoundDate(round, date);
      if (!roundDate.exists(roundDatesModel)) {
        roundDatesModel.addElement(roundDate);
      }
      else {
        JOptionPane.showMessageDialog(this, "Ronden finns redan", "Message", JOptionPane.INFORMATION_MESSAGE);
      }
    }
    catch (ParseException e) {
      JOptionPane.showMessageDialog(this, "Datum ska vara i formatet /MM/DD", "Message", JOptionPane.INFORMATION_MESSAGE);
    }
  }

  private void jButtonRemoveRoundDate_actionPerformed() {
    roundDatesModel.remove(jListRoundDates.getSelectedIndex());
  }

  private void jCheckBoxChess4_itemStateChanged(ItemEvent e) {
    if (jCheckBoxChess4.isSelected()) {
      jComboBoxPairingSystem.setSelectedItem("Monrad");
      jComboBoxPairingSystem.setEnabled(false);
      jComboBoxInitialPairing.setSelectedItem("Slumpad");
      jComboBoxInitialPairing.setEnabled(false);
      jComboBoxRatingChoice.setEnabled(false);
      jCheckBoxLASK.setSelected(false);
      jCheckBoxLASK.setEnabled(false);
      jCheckBoxELO.setSelected(false);
      jCheckBoxELO.setEnabled(false);
      jCheckBoxGroup.setSelected(false);
      jCheckBoxGroup.setEnabled(false);
      jPanelTiebreak.setEnabled(false);
      jCheckBoxBarred.setSelected(true);
      jCheckBoxCompensateWeakPlayerPP.setSelected(false);
      jCheckBoxCompensateWeakPlayerPP.setEnabled(false);
      jSpinnerPoints.setValue(new Integer(4));
      jSpinnerPoints.setEnabled(false);
    }
    else {
      jComboBoxPairingSystem.setEnabled(true);
      jComboBoxInitialPairing.setEnabled(true);
      jComboBoxRatingChoice.setEnabled(true);
      jCheckBoxLASK.setEnabled(true);
      jCheckBoxELO.setEnabled(true);
      jCheckBoxGroup.setEnabled(true);
      jPanelTiebreak.setEnabled(true);
      jCheckBoxCompensateWeakPlayerPP.setEnabled(true);
      jSpinnerPoints.setEnabled(true);
    }
  }
}
