package cp.tiebreak;

import cp.*;

import cp.Result.*;
import java.util.Vector;

public class TiebreakBlacks implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   */
  public double getTiebreak(Round round, Player player) {
    double tiebreak = 0;
		// For each opponent that has the same score, add the internal result.
    Vector games = player.getGames();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);
      if (game.getRoundNr() <= round.getRoundNr()) {
				if (!game.plays(null)) {
				  Player black = game.getBlackPlayer();
					if (black == player) {
  			    tiebreak++;
					}
				}
      }
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Svarta partier";
  }

  public String getShortName() {
    return "Svart";
  }
  
  public String format(double value) {
    return Integer.toString((int) value);
  }
  
  
}
