package cp.tiebreak;

import cp.Game;
import cp.Games;
import cp.Player;
import cp.Round;
import cp.Rounds;

import java.util.Vector;

public class TiebreakInternalMeeting implements Tiebreak {
  
  /**
   * Calculates the tiebreak score for a player up to a given round.
   */
  public double getTiebreak(Round round, Player player) {
		double score = player.getScore(round);
    double tiebreak = 0;
		// For each opponent that has the same score, add the internal result.
    Vector games = player.getGames();
    for (int i = 0; i < games.size(); i++) {
      Game game = (Game)games.get(i);
      if (game.getRoundNr() <= round.getRoundNr()) {
				if (!game.plays(null)) {
					Player white = game.getWhitePlayer();
					Player black = game.getBlackPlayer();
					if (white == player) {
						if (black.getScore(round) == score) {
							tiebreak += game.getResult().getWhiteScore();
						}
					}
					else if (black == player) {
					  if (white.getScore(round) == score) {
					    tiebreak += game.getResult().getBlackScore();
					  }
					}
				}
      }
    }
    return tiebreak;
  }
  
  public String toString() {
    return "Inbrdes mte";
  }

  public String getShortName() {
    return "Inb";
  }
  
  public String format(double value) {
    return Double.toString(value);
  }

}
